﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Data.OleDb;
using C1.Win.FlexReport;
using System.Diagnostics;
using C1.Win.C1Document;

namespace prj_FlexReport
{
    public partial class Form1 : Form
    {
        
        public Form1()
        {
            InitializeComponent();
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            Stopwatch stopWatch = new Stopwatch();
            Render();
            stopWatch.Start();
            FlexViewer.DocumentSource = FlexReport;
            stopWatch.Stop();
            TimeSpan ts = stopWatch.Elapsed;
            // Format and display the TimeSpan value.
            string elapsedTime = String.Format("{0:00}:{1:00}:{2:00}.{3:00}",
                ts.Hours, ts.Minutes, ts.Seconds, ts.Milliseconds);
            Console.WriteLine("RunTime " + elapsedTime);
        }
        private void Form1_Load_Old(object sender, EventArgs e)
        {
            Stopwatch stopWatch = new Stopwatch();
            FlexReport.Load("../../Products.flxr", "Products");
            stopWatch.Start();
            FlexViewer.DocumentSource = FlexReport;
            stopWatch.Stop();
            TimeSpan ts = stopWatch.Elapsed;
            // Format and display the TimeSpan value.
            string elapsedTime = String.Format("{0:00}:{1:00}:{2:00}.{3:00}",
                ts.Hours, ts.Minutes, ts.Seconds , ts.Milliseconds);
            Console.WriteLine("RunTime " + elapsedTime);
        }
        
        public void Render()
        {

            //prevent reentrant calls
            if (FlexReport.IsBusy) return;

            FlexReport.Clear();


            //C1Report.Layout)
            Layout l = FlexReport.Layout;
            l.MarginLeft = 100;
            l.MarginRight = 100;
            l.MarginBottom = 50;
            l.MarginTop = 100;

            l.PaperSize = System.Drawing.Printing.PaperKind.A4;
            l.PageFooter = HdrFtrEnum.AllPages;

            
            l.Orientation = OrientationEnum.Landscape;
            int width = 15600;
            float fontSize = 8;

            // create a Page header
            Section s = FlexReport.Sections[SectionTypeEnum.PageHeader]; s.Visible = true;
            // create a Page header
            int topPos = 0,height = 300;
            s.Fields.Add(new RepoField("Header", true, fontSize, 500, topPos, width, height, FieldAlignEnum.CenterMiddle, true));

            topPos = topPos + 500;
            s.Fields.Add(new RepoField("ABC COMPANY", false, fontSize, 500, topPos, width, height));
            s.Fields.Add(new RepoField("FINANCIAL YEAR", false, fontSize, 500, topPos, width, height, FieldAlignEnum.RightMiddle));

            topPos = topPos + 300;
            s.Fields.Add(new RepoField("PERIOD", false, fontSize, 500, topPos, width, height, FieldAlignEnum.RightMiddle));
            s.Height = topPos;
            
            topPos = 300; height = 400;
            s.Fields.Add(new RepoField("From Miti:  To: ", false, fontSize, 500, topPos, width, height, FieldAlignEnum.CenterMiddle));

            topPos = topPos + 200;
            s.Fields.Add(new RepoField("From Date:  To: ", false, fontSize, 500, topPos, width, height, FieldAlignEnum.CenterMiddle));

            topPos = topPos + 700;
            s.Fields.Add(new RepoLine(500, topPos, width));

            topPos = topPos + 20;
            s.Fields.Add(new RepoLine(500, topPos, width));

            s.Fields.Add(new RepoField("MITI", true, fontSize, 500, topPos, 1000, height, FieldAlignEnum.LeftMiddle));
            s.Fields.Add(new RepoField("DATE", true, fontSize, 1500, topPos, 1000, height, FieldAlignEnum.LeftMiddle));
            s.Fields.Add(new RepoField("DOC_TYPE", true, fontSize, 2500, topPos, 1000, height, FieldAlignEnum.LeftMiddle));
            s.Fields.Add(new RepoField("DOC_NO", true, fontSize, 3500, topPos, 1000, height, FieldAlignEnum.LeftMiddle));
            s.Fields.Add(new RepoField("LEDGER_NAME", true, fontSize, 4500, topPos, 4500, height, FieldAlignEnum.LeftMiddle));
            s.Fields.Add(new RepoField("NARRATION", true, fontSize, 9000, topPos, 4100, height, FieldAlignEnum.LeftMiddle));
            s.Fields.Add(new RepoField("DR_AMT", true, fontSize, 13100, topPos, 1500, height, FieldAlignEnum.RightMiddle));
            s.Fields.Add(new RepoField("CR_AMT", true, fontSize, 14600, topPos, 1500, height, FieldAlignEnum.RightMiddle));

            topPos += height;
            s.Fields.Add(new RepoLine(500, topPos, width));
            s.Height = topPos;

            s = FlexReport.Sections[SectionTypeEnum.Detail]; s.Visible = true;
            topPos = 0;

            List<RokadReport> rokadReports = DummyData.Data;
            //.Where(x=>Convert.ToInt32(x.Miti.Replace("-",""))<=20750405).ToList();
            //filtered will work but still slow


            foreach (RokadReport item in rokadReports)
            {
                s.Fields.Add(new RepoField(item.Miti, false, fontSize, 500, topPos, 1000, height, FieldAlignEnum.LeftMiddle));
                s.Fields.Add(new RepoField(item.Dated.ToString(), false, fontSize, 1500, topPos, 1000, height, FieldAlignEnum.LeftMiddle));
                s.Fields.Add(new RepoField(item.DocType, false, fontSize, 2500, topPos, 1000, height, FieldAlignEnum.LeftMiddle));
                s.Fields.Add(new RepoField(item.DocNo, false, fontSize, 3500, topPos, 1000, height, FieldAlignEnum.LeftMiddle));
                s.Fields.Add(new RepoField(item.LedgerName, false, fontSize, 4500, topPos, 4500, height, FieldAlignEnum.LeftMiddle));
                s.Fields.Add(new RepoField(item.Narration, false, fontSize, 9000, topPos, 4100, height, FieldAlignEnum.LeftMiddle));
                s.Fields.Add(new RepoField(item.DrAmt.ToString("0.00"), false, fontSize, 13100, topPos, 1500, height, FieldAlignEnum.RightMiddle));
                s.Fields.Add(new RepoField(item.CrAmt.ToString("0.00"), false, fontSize, 14600, topPos, 1500, height, FieldAlignEnum.RightMiddle));

                topPos += height;
            }
            topPos -= height;
            s.Fields.Add(new RepoLine(500, topPos, width));
            topPos += height;
            s.Fields.Add(new RepoLine(500, topPos, width));

            s.Height = topPos;

            // create a page footer
            s = FlexReport.Sections[SectionTypeEnum.PageFooter]; s.Visible = true;
            topPos = 0;
            s.Fields.Add(new RepoField("Printed on Date:" + DateTime.Now.ToString("dd-MM-yyyy")+ " " + DateTime.Now.DayOfWeek + ", " + DateTime.Now.ToShortTimeString() + " , By ", false, fontSize, 500, topPos, width, height));
            RepoField fld = new RepoField(@"""Page "" & Page & "" of "" & Pages", false, fontSize, 500, topPos, width, height, FieldAlignEnum.RightMiddle)
            {
                Calculated = true
            };
            s.Fields.Add(fld);

            s.Fields.Add(new RepoLine(500, topPos, width));
            s.Height = height * 2;
        }

    }
    
    public class RepoField : Field
    {
        public RepoField
        (
            string text = "",
            bool bold = false,
            float fontsize = 7,
            int left = 0,
            int top = 0,
            int width = 0,
            int height = 0,
            FieldAlignEnum align = FieldAlignEnum.LeftMiddle,
            bool underline = false
        )
        {
            this.Font.Name = "Consolas";
            this.Font.Size = fontsize;
            this.Font.Bold = bold;
            this.Font.Underline = underline;

            this.Font.Bold = bold;
            this.Text = text;
            this.Left = left;
            this.Top = top;
            this.Width = width;
            this.Height = height;
            this.Align = align;
        }
    }
    public class RepoLine : RepoField
    {
        public RepoLine(int left, int top, int width)
        {
            this.Left = left;
            this.Top = top;
            this.Width = width;
            this.Height = 10;
            this.ShapeType= C1.Win.C1Document.ShapeType.Line;
            this.Border = new Border(10, Color.Black, DashStyle.Solid);
        }
    }
}
